<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component, Prop, Watch } from "vue-property-decorator";
import StoreGalleryModule from "~/store/storeGallery";
import { api } from "~/common/constaint";
import { apiErrorHandler } from "~/utils/apiHanlers";
@Component({})
export default class StoreGalleryComponent extends Vue {
  storeGallery = getModule(StoreGalleryModule, this.$store);

  @Prop({ default: false })
  isSelectMultipleImage!: boolean;

  @Prop()
  isShowUploadPhoto!: boolean;

  @Prop()
  limitImage!: boolean;

  @Prop()
  dialogMediaPicker!: boolean;

  @Prop()
  imageAdd!: string;

  @Prop()
  imageVariant!: any;

  @Prop({ default: false })
  isImageVariant!: boolean;

  @Prop()
  tiptapWord!: boolean;

  @Prop()
  imageType!: string;

  @Prop()
  imageId!: string;

  search = "";

  gallery = {
    storeId: "",
    file: null,
  };

  dialogCreateTag = false;
  dialogRenameTag = false;
  dialogDeleteTag = false;
  dialogDeleteImage = false;
  nameTag = "";
  storeId = this.$route.params.id;

  coverId = "";
  listCoverId: any = [];
  loading = false;

  mounted() {
    this.onGetListImgCategory();
  }

  beforeDestroy() {
    this.openDialogCloseUploadImage();
  }

  async onGetListImgCategory() {
    try {
      this.loading = true;
      await this.$store.dispatch("storeGallery/onGetListImgCategory", {
        ctx: this,
        storeId: this.storeId,
      });
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async selectedImage(gallery: any) {
    if (this.limitImage) {
      this.coverId = gallery._id;
    } else {
      const findIndex = this.listCoverId.findIndex(
        (cover: any) => cover._id === gallery._id
      );
      if (findIndex === -1) {
        this.listCoverId.push({
          _id: gallery._id,
          imageUrl: gallery.imageUrl,
        });
      } else {
        this.listCoverId.splice(findIndex, 1);
      }
    }
  }

  showImageChosen(gallery: any) {
    if (this.limitImage) {
      if (this.coverId === gallery._id) {
        return true;
      } else {
        return false;
      }
    } else {
      const findCoverId = this.listCoverId.find(
        (cover: any) => cover._id === gallery._id
      );
      if (findCoverId) {
        return true;
      }
      return false;
    }
  }

  async onHandleSelectedImage() {
    if (this.limitImage) {
      const findImageUrl = this.listGallery.find(
        (gallery: any) => gallery._id === this.coverId
      );
      if (this.isImageVariant) {
        const imageVariant = {
          imageId: findImageUrl._id,
          imageUrl: findImageUrl.imageUrl || "",
        };
        this.$emit("update:imageVariant", imageVariant);
        this.$emit("update:isImageVariant", false);
      } else if (this.tiptapWord) {
        this.$emit("update:imageAdd", `${api}/${findImageUrl.imageUrl}`);
        this.$emit("update:tiptapWord", false);
      } else {
        await this.$store.commit("adminCollection/setCoverId", {
          coverId: this.coverId,
          imageUrl: findImageUrl?.imageUrl || "",
        });
        // await this.$store.commit("adminCollection/setCoverId", {
        // 	coverId: this.coverId,
        // 	imageUrl: findImageUrl?.imageUrl || "",
        // });
        // this.coverId = "";
      }
    } else {
      this.$store.commit("storeGallery/setListCoverId", this.listCoverId);
      this.listCoverId = [];
    }

    this.coverId = "";

    this.$emit("update:dialogMediaPicker", false);
    this.$emit("update:isSelectMultipleImage", false);
  }

  openDialogDeleteGallery() {
    if (!this.coverId) {
      return this.$pushNotification.error("Only one photo can be deleted");
    }
    this.dialogDeleteImage = true;
  }
  openDialogDeleteGalleryMultiple() {
    if (this.listCoverId.length > 1) {
      return this.$pushNotification.error("Only one photo can be deleted");
    }
    this.dialogDeleteImage = true;
  }
  async onHandleDeleteGallery() {
    try {
      this.loading = true;
      await this.$api.storeGallery.delete(
        this.storeId,
        this.coverId || this.listCoverId[0]._id
      );
      this.$pushNotification.success("Delete photo successfully");
      this.onGetListImgCategory();
      this.coverId = "";
      this.listCoverId = [];
      this.dialogDeleteImage = false;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  onSelectImage() {
    //@ts-ignore
    this.$refs.fileImage.$refs.input.click();
  }

  onChangeImage(e: any) {
    if (e.length > 0) {
      for (let item of e) {
        if (!item.type.includes("image/")) {
          continue;
        }
      }
      this.gallery.file = e;
    }
  }

  dragover(event: any) {
    event.preventDefault();
    // Add some visual fluff to show the user can drop its files
    //   if (!event.currentTarget.classList.contains('bg-green-300')) {
    //     event.currentTarget.classList.remove('bg-gray-100');
    //     event.currentTarget.classList.add('bg-green-300');
    //   }
  }
  dragleave(event: any) {
    // Clean up
    //   event.currentTarget.classList.add('bg-gray-100');
    //   event.currentTarget.classList.remove('bg-green-300');
  }
  drop(event: any) {
    event.preventDefault();
    //@ts-ignore
    // this.$refs.fileImage.files = event.dataTransfer.files;
    if (event.dataTransfer.files.length > 0) {
      this.gallery.file = event.dataTransfer.files;
    }
  }

  openDialogCloseUploadImage() {
    this.$store.commit("storeGallery/setValueBoolane", {
      status: false,
      type: "isUploadImage",
    });
  }

  convertImage(url: string) {
    return `${api}/${url}`;
  }

  get loadingTableTag() {
    return this.$store.state["storeGallery"].loadingTableTag;
  }

  get loadingHandler() {
    return this.$store.state["storeGallery"].loading;
  }

  get loadingTable() {
    return this.$store.state["storeGallery"].loadingTable;
  }

  get listTag() {
    return this.$store.state["storeGallery"].listTag;
  }

  get listGallery() {
    return this.$store.state["storeGallery"].listGallery;
  }

  get isUploadImage() {
    return this.$store.state.storeGallery.isUploadImage;
  }

  get progressUploadImage() {
    return this.$store.state.storeGallery.progress;
  }
  get isGallery() {
    // if (window.location.href.includes("/admin/gallery")) {
    // 	return true;
    // }
    return false;
  }

  @Watch("gallery.file")
  changedFileImage(val: any) {
    if (val) {
      const formData = new FormData();
      for (const img of val) {
        formData.append("images", img);
      }

      this.$store.dispatch("storeGallery/onUploadImageGallery", {
        ctx: this,
        payload: formData,
        storeId: this.storeId,
      });
    }
  }

  @Watch("dialogCreateTag")
  changedDialogCreateTag(val: boolean) {
    if (!val) {
      this.nameTag = "";
    }
  }

  @Watch("dialogRenameTag")
  changedDialogUpdateTag(val: boolean) {
    if (!val) {
      this.nameTag = "";
    }
  }
}
</script>

<style src="./style.css"></style>
